require File.dirname(__FILE__) + '/methods/base'
Dir[File.dirname(__FILE__) + '/methods/*.rb'].each { |file| require file }

module Nabortu
  class Client
    def send_payment(reserve_id)
      url = URI.parse(Nabortu.config.payment_url)

      request = Net::HTTP::Post.new(url.path, {'Content-Type' =>'application/json', 'Accept' => 'application/json'})
      request.body = {orderId: reserve_id.to_s}.to_json
      request.basic_auth(url.user, url.password)

      http = Net::HTTP.new(url.host, url.port)
      http.request(request)
    end

    def method_missing(name, params, args = {})
      klass = ['Nabortu', 'Methods', name.to_s.camelize].join('::')

      if Object.const_defined? klass
        klass.constantize.do_request(name, params)
      else
        raise Nabortu::Errors::WrongMethod.new("Nabortu API does not have '#{name}' method or it\'s not implemented")
      end
    end
  end
end
